// CommunicationControl.cpp : implementation file
//

#include "stdafx.h"
#include "Dial Application.h"
#include "CommunicationControl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCommunicationControl dialog


CCommunicationControl::CCommunicationControl(CWnd* pParent /*=NULL*/)
	: CDialog(CCommunicationControl::IDD, pParent)
{
	
	//{{AFX_DATA_INIT(CCommunicationControl)
	m_cdholding = _T("");
	m_commport = _T("");
	m_ctsholding = _T("");
	m_dsrholding = _T("");
	m_dtrenable = _T("");
	m_eofenable = _T("");
	m_inputmode = _T("");
	m_portopen = _T("");
	m_rtsenable = _T("");
	m_settings = _T("");
	m_situationmodem = _T("");
	m_handsharing = _T("");
	m_inbuffercount = 0;
	m_inbuffersize = 0;
	m_outbuffersize = 0;
	m_outbuffercount = 0;
	m_rthreshold = 0;//_T("");
	m_sthreshold = 0;
	//}}AFX_DATA_INIT

}


void CCommunicationControl::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCommunicationControl)
	DDX_Control(pDX, IDC_BOPEN, m_bopen);
	DDX_Control(pDX, IDC_BDEFAULT, m_bdefault);
	DDX_Control(pDX, IDC_BCLOSE, m_bclose);
	DDX_Text(pDX, IDC_CDHOLDING, m_cdholding);
	DDX_Text(pDX, IDC_COMMPORT, m_commport);
	DDX_Text(pDX, IDC_CTSHOLDING, m_ctsholding);
	DDX_Text(pDX, IDC_DSRHOLDING, m_dsrholding);
	DDX_Text(pDX, IDC_DTRENABLE, m_dtrenable);
	DDX_Text(pDX, IDC_EOFENABLE, m_eofenable);
	DDX_Text(pDX, IDC_INPUTMODE, m_inputmode);
	DDX_Text(pDX, IDC_PORTOPEN, m_portopen);
	DDX_Text(pDX, IDC_RTSENABLE, m_rtsenable);
	DDX_Text(pDX, IDC_SETTINGS, m_settings);
	DDX_Text(pDX, IDC_SITUATION_MODEM, m_situationmodem);
	DDX_Text(pDX, IDC_HANDSHARING, m_handsharing);
	DDX_Text(pDX, IDC_INBUFFERCOUNT, m_inbuffercount);
	DDX_Text(pDX, IDC_INBUFFERSIZE, m_inbuffersize);
	DDX_Text(pDX, IDC_OUTBUFFERSIZE, m_outbuffersize);
	DDX_Text(pDX, IDC_OUTBUFFERCOUNT, m_outbuffercount);
	DDX_Text(pDX, IDC_RTHRESHOLD, m_rthreshold);
	DDX_Text(pDX, IDC_STHRESHOLD, m_sthreshold);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCommunicationControl, CDialog)
	//{{AFX_MSG_MAP(CCommunicationControl)
	ON_BN_CLICKED(IDC_BCLOSE, OnBclose)
	ON_BN_CLICKED(IDC_BDEFAULT, OnBdefault)
	ON_BN_CLICKED(IDC_BOPEN, OnBopen)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCommunicationControl message handlers

BOOL CCommunicationControl::OnInitDialog() 
{
	CDialog::OnInitDialog();

	CMenu* pSysMenu = GetSystemMenu(FALSE);

	pSysMenu->RemoveMenu(SC_SIZE, MF_BYCOMMAND);
	pSysMenu->RemoveMenu(SC_MAXIMIZE, MF_BYCOMMAND);	

	vflag = 2; //default
	properties(vflag);

	m_bopen.EnableWindow(TRUE);
	m_bclose.EnableWindow(FALSE);
	m_bdefault.EnableWindow(TRUE);

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
	

void CCommunicationControl::properties(int flag)
{	
	CMainFrame* pMainWnd = (CMainFrame*)AfxGetMainWnd();
	
    if (!pMainWnd->GetMSComm()->GetPortOpen())
		pMainWnd->GetMSComm()->SetPortOpen(TRUE);

	if ((pMainWnd->GetMSComm()->GetCTSHolding()) && (pMainWnd->GetMSComm()->GetDSRHolding()))
	{
		m_situationmodem = "Modem Installed";
	}
	else
	{
		m_situationmodem = "no Modem Installed";
	}
//**********************************************************************
		switch (flag)
	{
	case 1:      //port open 
		if (!pMainWnd->GetMSComm()->GetPortOpen())
			pMainWnd->GetMSComm()->SetPortOpen(TRUE);
		m_portopen ="COM Port Opended";

		m_bopen.EnableWindow(FALSE);
		m_bclose.EnableWindow(TRUE);
		m_bdefault.EnableWindow(TRUE);
		break;
	case 2:     //port close or default
		if (pMainWnd->GetMSComm()->GetPortOpen())
			pMainWnd->GetMSComm()->SetPortOpen(FALSE);
		m_portopen ="COM Port Closed";
	
		m_bopen.EnableWindow(TRUE);
		m_bclose.EnableWindow(FALSE);
		m_bdefault.EnableWindow(TRUE);

		break;
	}

//*********************************************************************
	m_settings = pMainWnd->GetMSComm()->GetSettings();

	int ComN = pMainWnd->GetMSComm()->GetCommPort();
	char StrComN[1];
	_itoa(ComN,StrComN,10);

	CString comstr("COM");
	comstr.Insert(3,StrComN);

	m_commport = comstr;

	m_sthreshold = pMainWnd->GetMSComm()->GetSThreshold();
	m_rthreshold = pMainWnd->GetMSComm()->GetRThreshold();

	if (pMainWnd->GetMSComm()->GetCDHolding())
		m_cdholding = "True";
	else
		m_cdholding ="False";

	if (pMainWnd->GetMSComm()->GetCTSHolding())
		m_ctsholding = "True";
	else
		m_ctsholding ="False";

	if (pMainWnd->GetMSComm()->GetDSRHolding())
		m_dsrholding = "True";
	else
		m_dsrholding ="False";

	if (pMainWnd->GetMSComm()->GetEOFEnable())
		m_eofenable = "True";
	else
		m_eofenable ="False";

	if (pMainWnd->GetMSComm()->GetRTSEnable())
		m_rtsenable = "True";
	else
		m_rtsenable ="False";

	if (pMainWnd->GetMSComm()->GetDTREnable())
		m_dtrenable = "True";
	else
		m_dtrenable ="False";

	if (pMainWnd->GetMSComm()->GetInputMode() == 0)
		m_inputmode = "Text Data";
	else
		m_inputmode ="Binary Data";

	switch (pMainWnd->GetMSComm()->GetHandshaking())
	{
	case 0:
		m_handsharing = "None";
		break;
	case 1:
		m_handsharing = "Software Xon/Xoff";
		break;
	case 2:
		m_handsharing = "Hardware RTS/CTS";
		break;
	case 3:
		m_handsharing = "RTS/XonXoff";
		break;

	}

	m_inbuffercount = pMainWnd->GetMSComm()->GetInBufferCount();
	m_inbuffersize = pMainWnd->GetMSComm()->GetInBufferSize();


	m_outbuffercount = pMainWnd->GetMSComm()->GetOutBufferCount();
	m_outbuffersize = pMainWnd->GetMSComm()->GetOutBufferSize();

	m_outbuffersize = pMainWnd->GetMSComm()->GetOutBufferSize();

	UpdateData(false);

}

void CCommunicationControl::OnBclose() 
{
	//port close
	
	vflag = 2;           
	properties(vflag);

	m_bopen.EnableWindow(TRUE);
	m_bclose.EnableWindow(FALSE);
	m_bdefault.EnableWindow(TRUE);

	// TODO: Add your control notification handler code here
	
}

void CCommunicationControl::OnBdefault() 
{
	//port open or default
	
	vflag = 2;           
	properties(vflag);

	m_bopen.EnableWindow(TRUE);
	m_bclose.EnableWindow(FALSE);
	m_bdefault.EnableWindow(TRUE);

	// TODO: Add your control notification handler code here
	
}

void CCommunicationControl::OnBopen() 
{
	//port open or default
	
	vflag = 1;           
	properties(vflag);

	m_bopen.EnableWindow(FALSE);
	m_bclose.EnableWindow(TRUE);
	m_bdefault.EnableWindow(TRUE);

	// TODO: Add your control notification handler code here
	
}

void CCommunicationControl::OnDestroy() 
{
	CDialog::OnDestroy();
	CMainFrame* pMainWnd = (CMainFrame*)AfxGetMainWnd();
	
    if (pMainWnd->GetMSComm()->GetPortOpen())
		pMainWnd->GetMSComm()->SetPortOpen(FALSE);
	
//	CInputDialNumber dlg;
//	dlg.m_edinterval = 0.0;
	// TODO: Add your message handler code here
	
}
